import struct

class AgosAppError(Exception):
    pass

class EncoderError(AgosAppError):
    pass

class DecoderError(AgosAppError):
    pass

class NotImplementedError(AgosAppError):
    pass

class NotSupportedError(AgosAppError):
    pass

def readByte(source_file):
    return ord(source_file.read(1))

def writeByte(value):
    return struct.pack('B', value)

def readSignedByte(source_file):
    return struct.unpack('b', source_file.read(1))[0]

def writeSignedByte(value):
    return struct.pack('b', value)

def readUint16(source_file):
    return struct.unpack('>H', source_file.read(2))[0]

def readUint32(source_file):
    return struct.unpack('>I', source_file.read(4))[0]

def myhex(value):
    return hex(value).lstrip('L').upper()
