import logging
from agos_encode import *

def _test(args):
    logging.basicConfig(format="", level=logging.DEBUG)
    if len(args) > 1:
        logging.error("Please only pass one zone ID as the argument.")
        sys.exit(-1)
    elif len(args) == 0:
        encodeVgaBitmaps(75)
    else:
        encodeVgaBitmaps(int(args[0]))
    sys.exit(0)

def _test_pack_all(args):
    logging.basicConfig(format="", level=logging.DEBUG)
    sourceData = array('B', [
        11, 44,
        22, 55,
        33, 66,
    ])
    size = (2, 3)
    expected_result = array('B', [
        250, # actually -6
        11, 22, 33, 44, 55, 66
    ])
    _test_pack(sourceData, size, expected_result, 1)

    sourceData = array('B', [
        11, 11,
        11, 22,
        11, 22,
        11, 33,
    ])
    size = (2, 4)
    expected_result = array('B', [
        4, # number of reps after the initial value - while there are 3 occurrances, there are two repititions.
        11,
        1,
        22,
        255,
        33
    ])
    _test_pack(sourceData, size, expected_result, 2)

    sourceData = array('B')
    source_file = file('Res0_Image9.png.raw', 'rb')
    sourceData.fromstring(source_file.read())
    source_file.close()
    size = (32, 15)
    expected_result = array('B')
    expected_result_file = file('Res0_Image9.orig.raw', 'rb')
    expected_result.fromstring(expected_result_file.read())
    expected_result_file.close()
    _test_pack(sourceData, size, expected_result, 3, is_4bit=False)


def _test_pack(sourceData, size, expected_result, test_num, is_4bit=True):
    logging.debug("Input: %s" % sourceData)
    width, height = size
    if not is_4bit:
        sourceData = convertTo4Bit(sourceData, width, height)
        width = width / 2
    columnData = convertToColumns(sourceData, width, height)
    result = packColumns(columnData, width, height)
    result_out_file = file('result_out_%d' % test_num, 'wb')
    result.tofile(result_out_file)
    result_out_file.close()


    print ("Output: %s" % str(result))
    assert len(result) == len(expected_result)
    assert result == expected_result
    print "Test okay"

if __name__ == "__main__": _test_pack_all(sys.argv[1:])